#ifndef __JPENQUAN_H
#define __JPENQUAN_H

#include <memory.h>
#include "jpeg.h"
class JpegDecoder ;

class JpegEncoderQuantizationTable
{
public:
  JpegEncoderQuantizationTable() ;
  ~JpegEncoderQuantizationTable() {}

  UBYTE2 operator[](unsigned int index) const ;
  UBYTE2 &operator[](unsigned int index) ;

private:
  JpegEncoderQuantizationTable (const JpegEncoderQuantizationTable&) ;
  JpegEncoderQuantizationTable &operator=(const JpegEncoderQuantizationTable&) ;

  UBYTE2 data_values [JpegSampleSize] ;

  friend class JpegEncoderDataUnit ;
} ;

inline JpegEncoderQuantizationTable::JpegEncoderQuantizationTable()
{
  memset (data_values, 0, sizeof (data_values)) ;
  return ;
}

inline UBYTE2 JpegEncoderQuantizationTable::operator[](unsigned int index) const
{
  return data_values [index] ;
}

inline UBYTE2 &JpegEncoderQuantizationTable::operator[](unsigned int index)
{
  return data_values [index] ;
}

#endif
